commit fd07644252996feaf0d724e3fef0455cad7aa8e9
Author: freddy77 <freddy77>
Date:   Tue Sep 1 08:02:36 2009 +0000

    fix numeric -> numeric conversions

diff --git a/ChangeLog b/ChangeLog
index a87a933..8ff8f21 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Sep  1 10:01:45 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/dblib.c: fix numeric -> numeric conversions
+
 Tue Sep  1 07:47:25 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/rpc.c src/dblib/unittests/.cvsignore:
 	* src/dblib/unittests/Makefile.am src/dblib/unittests/common.c:
@@ -1827,4 +1830,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2865 2009/09/01 05:47:31 freddy77 Exp $
+$Id: ChangeLog,v 1.2866 2009/09/01 08:02:36 freddy77 Exp $
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index f80892b..15956f3 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.352 2009/08/25 14:25:35 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.353 2009/09/01 08:02:36 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -2190,8 +2190,19 @@ dbconvert(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT srclen, int d
 	if (srclen == -1)
 		srclen = (int)strlen((const char *) src);
 
+	/* FIXME what happen if client do not reset values ??? */
+	/* FIXME act differently for ms and sybase */
+	if (is_numeric_type(desttype)) {
+		num = (DBNUMERIC *) dest;
+		if (num->precision <= 0 || num->precision > MAXPRECISION || num->scale < 0 || num->scale > num->precision) {
+			dres.n.precision = 18;
+			dres.n.scale = 0;
+		} else {
+			dres.n.precision = num->precision;
+			dres.n.scale = num->scale;
+		}
 	/* oft times we are asked to convert a data type to itself */
-	if (srctype == desttype) {
+	} else if (srctype == desttype) {
 		ret = -2;  /* to make sure we always set it */
 		tdsdump_log(TDS_DBG_INFO1, "dbconvert() srctype == desttype\n");
 		switch (desttype) {
@@ -2262,12 +2273,6 @@ dbconvert(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT srclen, int d
 			memcpy(dest, src, ret);
 			break;
 
-		case SYBNUMERIC:
-		case SYBDECIMAL:
-			memcpy(dest, src, sizeof(DBNUMERIC));
-			ret = sizeof(DBNUMERIC);
-			break;
-
 		default:
 			ret = -1;
 			break;
@@ -2276,7 +2281,6 @@ dbconvert(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT srclen, int d
 		return ret;
 	}
 	/* end srctype == desttype */
-	assert(srctype != desttype);
 
 	/*
 	 * Character types need no conversion.  Just move the data.
@@ -2288,20 +2292,6 @@ dbconvert(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT srclen, int d
 		}
 	}
 
-	/* FIXME what happen if client do not reset values ??? */
-	/* FIXME act differently for ms and sybase */
-	if (is_numeric_type(desttype)) {
-		num = (DBNUMERIC *) dest;
-		if (num->precision == 0)
-			dres.n.precision = 18;
-		else
-			dres.n.precision = num->precision;
-		if (num->scale == 0)
-			dres.n.scale = 0;
-		else
-			dres.n.scale = num->scale;
-	}
-
 	tdsdump_log(TDS_DBG_INFO1, "dbconvert() calling tds_convert\n");
 
 	len = tds_convert(g_dblib_ctx.tds_ctx, srctype, (const TDS_CHAR *) src, srclen, desttype, &dres);
@@ -7125,7 +7115,16 @@ copy_data_to_host_var(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT s
 
 	/* oft times we are asked to convert a data type to itself */
 
-	if ((srctype == desttype) ||
+	if (is_numeric_type(desttype)) {
+		num = (DBNUMERIC *) dest;
+		if (num->precision <= 0 || num->precision > MAXPRECISION || num->scale < 0 || num->scale > num->precision) {
+			dres.n.precision = 18;
+			dres.n.scale = 0;
+		} else {
+			dres.n.precision = num->precision;
+			dres.n.scale = num->scale;
+		}
+	} else if ((srctype == desttype) ||
 		(is_similar_type(srctype, desttype))) {
 
 		tdsdump_log(TDS_DBG_INFO1, "copy_data_to_host_var() srctype == desttype\n");
@@ -7220,11 +7219,6 @@ copy_data_to_host_var(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT s
 			memcpy(dest, src, ret);
 			break;
 
-		case SYBNUMERIC:
-		case SYBDECIMAL:
-			memcpy(dest, src, sizeof(DBNUMERIC));
-			break;
-
 		default:
 			break;
 		}
@@ -7235,20 +7229,6 @@ copy_data_to_host_var(DBPROCESS * dbproc, int srctype, const BYTE * src, DBINT s
 
 	} /* end srctype == desttype */
 
-	assert(srctype != desttype);
-
-	if (is_numeric_type(desttype)) {
-		num = (DBNUMERIC *) dest;
-		if (num->precision == 0)
-			dres.n.precision = 18;
-		else
-			dres.n.precision = num->precision;
-		if (num->scale == 0)
-			dres.n.scale = 0;
-		else
-			dres.n.scale = num->scale;
-	}
-
 	len = tds_convert(g_dblib_ctx.tds_ctx, srctype, (const TDS_CHAR *) src, srclen, desttype, &dres);
 
 	tdsdump_log(TDS_DBG_INFO1, "copy_data_to_host_var(): tds_convert returned %d\n", len);

